/*日夜间共用js*/

/* 对于复杂的js，若日夜间代码仅有一两行日夜间的差距，可使用 ifeng.isNightMode(); 进行判断区分，将该复杂js代码放入此js，利于维护 */

var     EVENT_IMG_WIDTH = 0,            //运营位活动图片宽
        EVENT_IMG_HEIGHT = 0,           //运营位活动图片高
        EVENT_IMG_RADIO = 698 / 256;    //运营位活动图片宽高比
        /*房产相关*/
        houselp_p='<!-- IFENG_DOC_HOUSEBUILDING -->',
        housefy_p='<!-- IFENG_DOC_HOUSERESOURCES -->',
        housexq_p='<!-- IFENG_DOC_HOUSEESTATE -->',
        housedc_p='<!-- IFENG_DOC_HOUSESURVEY -->',
        househd_p='<!-- IFENG_DOC_HOUSEACTIVITY -->';
        jumpUrls = [];

// 获取正文距离顶部高度
function setAuthorTitleHeight(){
    var contentTop = 0;
    var detail_declare = document.getElementById('detail_declare');
    if(detail_declare && detail_declare.style.display == 'block') {
        contentTop = detail_declare.offsetTop ;
    } else {
        var content = document.getElementById('content');
        contentTop = content.offsetTop ;
    }
    ifeng.setAuthorTitleHeight(contentTop);
    console.log("setAuthorTitleHeight : " + contentTop);
}

//改变关注图标状态 （于Java调用）
function changeSubButtonImg(subState) {
    try{
        var newsType = ifeng.getNewsType();
        if(newsType == 'short') {   //短内容
            subSourceSuccessForShort().call(null, subState);
        } else {
            subSourceSuccessForDoc().call(null, subState);
        }
    } catch (e) {
       console.log("error:"+e);
    }
}


//显示事件运营位图片 （于Java调用）
function showBottomEventImg(imgUrl,linkType,linkUrl,isAuth,staticId) {
    EVENT_IMG_WIDTH = SCREEN_WIDTH - 24;
    EVENT_IMG_HEIGHT = Math.round(EVENT_IMG_WIDTH / EVENT_IMG_RADIO);
    var eventImgWrapper = document.getElementById('event_img_wrapper');
    eventImgWrapper.style.width = EVENT_IMG_WIDTH + 2 + 'px';
    eventImgWrapper.style.display = 'block';
    eventImgWrapper.onclick = function() {
       ifeng.onEventImgClick(linkType,linkUrl,isAuth,staticId);
    }
    var eventImage = document.getElementById('event_img');
    eventImage.style.width = EVENT_IMG_WIDTH + 'px';
    eventImage.style.height = EVENT_IMG_HEIGHT + 'px';
    eventImage.style.backgroundImage = 'url(' + imgUrl + ')';
}

//修复正文异常边距
function fixErrorSpace() {
    var content = document.getElementById("content");

    //如果视频的前一个标签是空p标签，将其下边距去掉
    var videoNodeList = content.getElementsByClassName("video")
    if(videoNodeList){
        for(j=0;j<videoNodeList.length;j++) {
             var pre = videoNodeList[j].previousSibling;
             if(pre && pre.tagName == 'P' && pre.innerText == ""){
                 pre.style.paddingBottom = "0px";
                 pre.style.marginBottom = "0px";
                 console.log("fixErrorSpace success");
             }
        }
    }

    fixTopVideoOrImgTopSpace();

    //移除正文最后一个元素的下边距
    removeLastElementBottomSpace(content);
    //重置音频位置
    initAudio();
    console.log("fixErrorSpace");
}

/*移除该元素及其最后一个子元素底部的padding和margin*/
function removeLastElementBottomSpace(parent) {
    if(parent) {

        parent.style.paddingBottom = "0px";
        parent.style.marginBottom = "0px";

        var children = parent.children;
        if(children && children.length > 0) {
            var lastChildren = children[children.length - 1];
            removeLastElementBottomSpace(lastChildren);
        }
    }
}

//当视频或图片开头时，调整视频和图片的上边距
function fixTopVideoOrImgTopSpace() {
    var detail_declare = document.getElementById("detail_declare");
    var content = document.getElementById("content");
    var allNodeList = content.childNodes;
    if(allNodeList.length <= 1) {
        return;
    }

    //视频上面有一个空p标签占位，所以需查找两个标签
    for(i=0;i<2;i++) {
        var node = allNodeList[i];
        if(detail_declare.style.display == 'none') {
           //当不展示转载声明时，正文由视频开头，需要调整视频上边距为4px
           if(node.id == "videoContent") {
                node.style.paddingTop = "0px";
                node.style.marginTop = "4px";
                console.log("fixTopVideoOrImgTopSpace:fix top video/img space success with no declare.");
                break;
           }
        } else {
            //当展示转载声明时，正文由视频或图片开头，需要调整上边距为3px
            if(node.id == "videoContent" || node.id == "imgPlaceholder") {
                node.style.paddingTop = "0px";
                node.style.marginTop = "3px";
                console.log("fixTopVideoOrImgTopSpace:fix top video/img space success.");
                break;
            }
        }
    }
    console.log("fixTopVideoOrImgTopSpace");
}


//折叠
function unfold(){

   ifeng.recordInitDetailHeight(document.body.scrollHeight);
   var unfoldField = document.getElementsByClassName('unfold-field')[0];

   if(ifeng.isFoldAllowed() && datas.getFoldRatio() > 0){
         var wrap = document.getElementsByClassName('wrap')[0];

         var clickIconArea = document.getElementsByClassName('unfold_field_icon')[0];
         var clickArea = document.getElementsByClassName('unfold-field_click_area')[0];

         var windowHeight = ifeng.getWindowHeightDpi();
         //减去不被折叠的高度
         var unfoldWrapHeight = document.getElementsByClassName('unfold_wrap')[0].offsetHeight;
         var contentHeight = document.body.scrollHeight - unfoldWrapHeight;

         //折叠后的高度(按屏幕比例折叠)
         var height = windowHeight * datas.getFoldRatio();

         //短于N屏（N由后端配置,根据字数做近似处理）的文章不进行折叠
         var isShortArticle = false;
         if(datas.getFoldLimit() > 0) {
            isShortArticle = (windowHeight * datas.getFoldLimit() >= contentHeight);
         }

         if(!isShortArticle && contentHeight > height){

             wrap.style.minHeight = wrap.style.height = wrap.style.maxHeight = height + 'px';

             wrap.style.overflow='hidden';
             unfoldField.style.display= 'block';

             clickArea.innerHTML = "加载剩余" + Math.floor( (1 - height / contentHeight) * 100 ) + "%";
             clickIconArea.onclick = clickArea.onclick = function(){

                ifeng.recordClickUnfold();
                //console.log("update detail contentHeight : " + contentHeight);
                wrap.style.minHeight = wrap.style.height = wrap.style.maxHeight = '100%';
                unfoldField.parentNode.removeChild(unfoldField);
             };
         }else{
             unfoldField.parentNode.removeChild(unfoldField);
         }
   }else{
         unfoldField.parentNode.removeChild(unfoldField);
   }

   console.log("unfold");
}
/*房产电话咨询调用*/
function houseCallPhone(tag,telephoneStr){
    ifeng.houseTelephone(tag,"'"+telephoneStr+"'");
}
/*房卡卡片活动跳转调用*/
function toHouseCardDetail(houseLinkUrl){
    ifeng.houseLink(houseLinkUrl);
}
/*房产频道房源卡片相关*/
function buildHouseCard(content){
    var houseCardLPStr = datas.getHouseCardLPJson();
    content = handleHouseContent(content,houselp_p,houseCardLPStr);

    var houseCardFYStr = datas.getHouseCardFYJson();
    content = handleHouseContent(content,housefy_p,houseCardFYStr);

    var houseCardXQStr = datas.getHouseCardXQJson();
    content = handleHouseContent(content,housexq_p,houseCardXQStr);

    var houseCardHDStr = datas.getHouseCardHDJson();
    content = handleHouseContent(content,househd_p,houseCardHDStr);

    var houseCardDCStr = datas.getHouseCardDCJson();
    content = handleHouseContent(content,housedc_p,houseCardDCStr);
    return content;
}
function handleHouseContent(content,flag_p,sourceJson){
    if(sourceJson != null && sourceJson != "null" && sourceJson != "" && sourceJson != 'undefined'&&Object.prototype.toString.call(sourceJson) == '[object String]'){
        var houseCardList = JSON.parse(sourceJson);
        content = handle_survey_position(content,flag_p,houseCardList.length,
                function(i) {
                    return houseCardList[i].html;
                });
    }
    return content;
}

/*正文短内容展示*/
function preShortDocImg(content){
    if(content.indexOf('<!-- IFENG_SHORTDOC_PIC -->') != -1){
        var allImgs = datas.getShortDocImgJson();
        var arrValue;//用于存放取出的数组的值
         try{
            var showImg = JSON.parse(allImgs);
            } catch (e) {
               showImg = undefined;
           }
        var shortDocImgContent = '<ul class="wbImgBox">';

        if(showImg.length <= 3){
            shortDocImgContent += '<li class="wbImgGroup">';
            for(var i=0;i<showImg.length;i++){
               arrValue=showImg[i];//数组的索引是从0开始的
               shortDocImgContent += buildShortDocImg(arrValue.thumbnailUrl,i,arrValue.url);
            }
            shortDocImgContent += '</li>';
        }else if(showImg.length == 4){
           var index = 0;
           for(var i=0;i<2;i++){
              shortDocImgContent += '<li class="wbImgGroup">';
              for(var j=0;j<2;j++){
                 arrValue=showImg[index];//数组的索引是从0开始的
                 shortDocImgContent += buildShortDocImg(arrValue.thumbnailUrl,index,arrValue.url);
                 index++;
              }
              shortDocImgContent += '</li>';
           }
        }else {
           var count = Math.ceil(showImg.length/3);
           var index = 0;
           for(var i=0;i<count;i++){
              shortDocImgContent += '<li class="wbImgGroup">';
              for(var j=0;j<3;j++){
                  arrValue=showImg[index];//数组的索引是从0开始的
                  if(index < showImg.length){
                    shortDocImgContent += buildShortDocImg(arrValue.thumbnailUrl,index,arrValue.url);
                  }else{
                     shortDocImgContent += '<div class="wbImgItem"></div>';
                  }
                 index++;
               }
              shortDocImgContent += '</li>';
           }
        }
        shortDocImgContent += '</ul>';
        var content = content.replace('<!-- IFENG_SHORTDOC_PIC -->',shortDocImgContent);
    }
    return content
}

//初始化文章标题
function initNewsTitle() {
    var newsType = ifeng.getNewsType();
    if(newsType == 'short') {   //短内容 不需要标题
        document.getElementById('title').style.display = "none";
    } else {
        document.getElementById('title').innerHTML = datas.getTitle();
    }
    return content
}

/*构建img*/
function buildShortDocImg(value,indexPosition,showUrl){
    jumpUrls[indexPosition] = showUrl;
    var imgLabel= '<div class="wbImgItem"> <img class="wbImgItemPic"  src="'+value+'" onclick="shortDocClickToDetailPopup('+indexPosition+')" alt=""></div>';
    return imgLabel;
}
/*跳转到DetailPopupLightbox图集页面*/
function shortDocClickToDetailPopup(position){
    console.log("position="+position);
    ifeng.popupLightbox(jumpUrls,position,"");
}

//稿源信息
function initSource(datas){
    try{
        var wrapper = document.getElementById('time-and-source-panel');
        wrapper.onclick = function(event) {
            ifeng.gotoSubscribe();
            event.stopPropagation();
        }
        var iconWrap = document.getElementById('cir');
        var icon = document.getElementById('source_icon');
        var iconTag = document.getElementById('source_tag');
        var source = document.getElementById('source');
        var timeLayout = document.getElementById('wrap_time_original');
        var time = document.getElementById('time');
        var subButton = document.getElementById('subscribe');
        var catesource = document.getElementById('catesource');
        var line = document.getElementById('verticalline');
        var detail_declare = document.getElementById('detail_declare');
        var catesource_str,isShowSign,type,cateName,imgPath,source_tag,declare,viewStyle,srcInfo;
        if(datas.getSubscribe()){
            isShowSign = datas.getSubscribe().getIsShowSign();
            catesource_str = datas.getSubscribe().getCateSourceForJs();
            type = datas.getSubscribe().getType();
            cateName = datas.getSubscribe().getCateNameForJs();
            imgPath = datas.getSubscribe().getLogo();
            source_tag = datas.getSubscribe().getHonorImg();
            declare = datas.getSubscribe().getDeclare();
            viewStyle = datas.getSubscribe().getView();
            srcInfo = datas.getSubscribe().getDescription();
        }

        var isNightMode = ifeng.isNightMode();
        var newsType = ifeng.getNewsType();
        if(isShowSign && typeof(isShowSign)!="undefined" && isShowSign == '1' && catesource_str && typeof(catesource_str)!="undefined" && catesource_str!=null && catesource_str!=""){
            catesource.style.display = "block";
            line.style.display = "block";

            catesource.innerHTML = catesource_str;
        }else{
            catesource.style.display = "none";
            line.style.display = "none";
        }

        if(typeof(type)!="undefined"){
            subButton.style.display = "block";
            if(newsType == 'short') {   //短内容
               //自媒体描述标签
               if(srcInfo!=null&&srcInfo!=""){
                   var src_info = document.getElementById('src_infro');
                   if(src_info!=null){
                        src_info.innerHTML = srcInfo;
                   }
               }else{
                   var src_infodiv = document.getElementById('src_infro');
                   if(src_infodiv!=null){
                        src_infodiv.style.display="none";
                   }
               }
               Ground.isSubscribe(subSourceSuccessForShort(),"");
            } else {
               Ground.isSubscribe(subSourceSuccessForDoc(),"");
               var src_infonormal = document.getElementById('src_infro');
               if(src_infonormal!=null){
                    src_infonormal.style.display="none";
               }
            }
        }else{
            subButton.style.display = "none";
        }
        if(typeof(cateName)!="undefined"){
           source.innerHTML = cateName;
        }else{
           source.style.display = "none";
        }

        time.innerHTML = datas.getUpdateTimeForDetail();

        //原创标签
        if(datas.getOriginalName()!=null&&datas.getOriginalName()!=""){
              var original_content = document.getElementById('original_content');
              if(original_content!=null){
                   original_content.innerHTML = datas.getOriginalName();
              }
        }else{
              var originadiv = document.getElementById('original_content');
              if(originadiv!=null){
                   originadiv.style.display="none";
              }
        }

        wrapper.style.display = 'block';
        icon.style.display = 'block';
        subButton.onclick = function(event) {
            if(newsType == 'short') {   //短内容
                Ground.addSubscribe(subSourceSuccessForShort(),"");
            } else {
                Ground.addSubscribe(subSourceSuccessForDoc(),"");
            }
            event.stopPropagation();
        };

        if(typeof(imgPath)!="undefined" && imgPath!=0){
        icon.style.display = 'block';
            Ground.loadImageDirectly(imgPath, null,
                loadImageSuccessInterceptor(icon),
                loadSubscriptImageFailInterceptor(icon,imgPath), 'forceLoad');
        }else if(cateName && typeof(cateName)!="undefined"){
            icon.style.display = 'block';
            Ground.loadImageDirectly(cateName, null,
                loadImageSuccessInterceptor(icon),
                loadSubscriptImageFailInterceptor(icon,cateName), 'forceLoad');
        }else{
            icon.style.display = "none";
            iconWrap.style.display = "none";
            time.style.left = "0px";
        }
        if(source_tag != 0){
                    iconTag.style.display = "block";
                    Ground.loadImageDirectly(source_tag, null,
                                        loadImageSuccessInterceptor(iconTag),
                                        loadSubscriptImageFailInterceptor(iconTag,source_tag), 'forceLoad');
        }

        //如果服务端字段为1 不允许进入自媒体首页，则隐藏自媒体头像
        if(subscribe.getForbidJump()=='1'){
            icon.style.display = "none";
            catesource.style.display = "none";
            line.style.display = "none";
            iconWrap.style.display = "none";
            source.style.paddingLeft="0px";
            time.style.paddingLeft="0px";
            time.style.left = "0px";
        }

        if(viewStyle == '2'){
            //左右结构
            iconWrap.style.display = "none";
            source.style.paddingLeft="0px";
            source.style.paddingTop="2px";
            var isNightMode = ifeng.isNightMode();
            if(isNightMode){
                 source.style.color = '#505050';
            }else{
                 source.style.color = '#A1A5AC';
            }
            catesource.style.display = "none";
             if(original_content != null){
                original_content.style.display = "none";
             }
            if(originadiv != null){
                originadiv.style.display="none";
            }
            timeLayout.className = 'wrap_time_original_two';
        }

        if(subscribe.getForbidFollow()=='1'){
            subButton.style.display = "none";
        }

        if(typeof(declare)!="undefined" && declare!=0 && viewStyle != '2') {
            detail_declare.style.display = "block";
            detail_declare.innerHTML = declare;
            document.getElementById('content').style.paddingTop = "0px";
        }
    }catch(e){
        console.log("error:"+e);
    }
}

/*正文 切换关注按钮状态*/
function subSourceSuccessForDoc() {
    return function(subState){
        var subButton = document.getElementById('subscribe');
        var isNightMode = ifeng.isNightMode();
        if(subState){
            var delSubImg = "delete_sub_detail.png";
            if(isNightMode) {
                delSubImg = "sub_delete_night.png";
            }
            subButton.setAttribute("src", delSubImg);
        }else{
            var addSubImg = "add_sub_detail.png";
            if(isNightMode) {
                addSubImg = "sub_add_night.png";
            }
            subButton.setAttribute("src", addSubImg);
        }
        console.log("subSourceSuccessForDoc");
    };
}


/*短内容 切换关注按钮状态*/
function subSourceSuccessForShort() {
    return function(subState){
        var subButton = document.getElementById('subscribe');
        subButton.style.width = "42px";
        subButton.style.height = "20px";
        subButton.style.top = "9px";
        var isNightMode = ifeng.isNightMode();
        if(subState){
            var delSubImg = "short_already_sub.png";
            if(isNightMode) {
                delSubImg = "short_already_sub_night.png";
            }
            subButton.setAttribute("src", delSubImg);
        }else{
            var addSubImg = "short_sub.png";
            if(isNightMode) {
                addSubImg = "short_sub_night.png";
            }
            subButton.setAttribute("src", addSubImg);
        }
        console.log("subSourceSuccessForShort");
    };
}


/*通知正文调查加载完成，用于直接滚动至调查位置*/
function notifySurveyHeadIfNeed() {
    var survey_head = document.getElementById('survey_head');
    if(survey_head){
        var offsetTop = window.devicePixelRatio*getTop(survey_head);
        console.log('survey_head，y:'+offsetTop);
        ifeng.docSurveyFinishLoad(offsetTop);
    }
}